﻿$(document).ready(function () {
    $('#PortalSearchbox').on('input', function () { //This would fire every time the input changes, so when you paste something (even with right click), delete and type anything.
        clearTimeout($.data(this, 'timerGetAutocomplete'));
        var wait = setTimeout(PortalSearch, 700); //latence
        $(this).data('timerGetAutocomplete', wait);
    });

    $('#PortalSearchbox').on('search', function () { //reaguje na krizek v Chrome
        PortalSearch();
    });

    $('#PortalSearchbox').focus(function (e) {
        var q = $(this).val();

        if (q.length > 0) {
            $(".portal-searchbox .ac_results").slideDown();
            e.stopPropagation();
        }
    });

    $('#PortalSearchbox').focusout(function () {//click mimo prohlizec
        if (!$(".portal-searchbox .ac_results").is(':visible')) {
        }
    });

    $('#PortalSearchbox, .portal-searchbox .ac_results').click(function (event) {
        event.stopPropagation(); // Prevent bubbling
    });

    $("html").click(function () {
        setTimeout(function () { //http://stackoverflow.com/questions/1094332/jquery-blur-fires-before-href
            $(".portal-searchbox .ac_results").slideUp('fast');
        }, 1);
    });

    $('.portal-searchbox .ac_results').on("click", ".portal-search-categories-results li.result", function (event) {
        $(".portal-searchbox .ac_results").slideUp('fast');
    });

}); //end document ready


var portalSearchMandate;

var $lastUl = null;

function InsertPortalResultUl($ul, insertAsFirst) {
    var $div = $(".portal-searchbox .ac_results");

    if ($lastUl != null && $lastUl.is(':visible')) { //visible, protoze uz muze byt ten div removnuty, pokud se nedojede az po posledni hledani, nenastavi se lastUl = null
        if (insertAsFirst) {
            $ul.prependTo($div);
        }
        else {
            $ul.insertAfter($lastUl);
        }
    }
    else {
        $ul.prependTo($div);
    }

    if (!insertAsFirst) {
        $lastUl = $ul;
    }
}

function PortalSearch() {
    var q = $('#PortalSearchbox').val();
    var $div = $(".portal-searchbox .ac_results");

    if (q.length > 0) {

        if ($div.find('.loading-16').length == 0) {
            $div.prepend('<div class="loading-16"></div>');
        }

        if (!$div.is(':visible')) {
            $div.find("ul.result").remove();
            //$div.width($('#PortalSearchbox').width());
            $div.slideDown();
        }

        $div.find("ul.not-found").hide();
        portalSearchMandate = Math.random().toString(36).substring(7);
        SearchPortalCategories(q, portalSearchMandate);
    }
    else {
        $div.slideUp('fast');
    }
}

function SearchPortalCategories(q, mandate) {
    var $div = $(".portal-searchbox .ac_results");

    $.post(
        RQ_URL + '/Portal/SearchPortalCategories',
        {
            text: q,
            portalId: $("#SelectedPortal").val(),
        },
        function (data) {
            if (portalSearchMandate == mandate) {
                $(".portal-search-categories-results").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "result portal-search-categories-results" });
                    $("<li></li>", { class: "main", text: "Kategorie" }).appendTo($ul);
                    var i = 0;

                    $(data).each(function () {
                        var $li = $("<li></li>", { class: "result" }).appendTo($ul);
                        var $i = $("<i></i>", { class: "fas fa-folder fa-lg fa-fw", style: "color: " + this.Color }).appendTo($li);
                        $li.append(" ");
                        var $a = $("<a></a>", { href: "javascript:loadCategory(" + this.Id + ")" }).appendTo($li);
                        $a.text(this.Name);
                        i++;
                    });

                    InsertPortalResultUl($ul, false);
                }

            }
        },
        "json"
    )
        .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
        .done(function () {
            if (portalSearchMandate == mandate) {
                SearchPortalItems(q, mandate);
            }
        });
}

function SearchPortalItems(q, mandate) {
    var $div = $(".portal-searchbox .ac_results");

    $.post(
        RQ_URL + '/Portal/SearchPortalItems',
        {
            text: q,
            portalId: $("#SelectedPortal").val(),
        },
        function (data) {
            if (portalSearchMandate == mandate) {
                $(".portal-search-items-results").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "result portal-search-items-results" });
                    $("<li></li>", { class: "main", text: "Položky" }).appendTo($ul);
                    var i = 0;

                    $(data).each(function () {
                        var $li = $("<li></li>", { class: "result" }).appendTo($ul);
                        if (this.HasImage) {
                            $("<img />", { class: 'fa-lg fa-fw', src: RQ_URL + '/Portal/GetIcon/' + this.Id + '?hash=' + this.ImageUrlHash }).appendTo($li);
                        }
                        else {
                            var $i = $("<i></i>", { class: this.FontIcon, style: "color: " + this.Color }).appendTo($li);
                            $i.addClass('fa-lg fa-fw');
                        }

                        $li.append(" ");
                        var $a = $("<a></a>", { href: RQ_URL + '/Tickets/New?portalItemId=' + this.Id }).appendTo($li);
                        $a.text(this.Name); 

                        if (this.Description != null) 
                        {
                            var $div = $("<div></div>", { class: 'description' }).appendTo($li);
                            $div.text(this.Description);
                        }
                        i++;
                    });

                    InsertPortalResultUl($ul, false);
                }

            }
        },
        "json"
    )
        .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
        .done(function () {
            if (portalSearchMandate == mandate) {

                if ($(".portal-searchbox .ac_results li.result").length == 0) {
                    $(".portal-searchbox .ac_results ul.not-found").show();
                }

                $div.find("div.loading-16").remove();
            }
        });
}